#ifndef MEMORYLEAK_HEADER
#define MEMORYLEAK_HEADER
#include <Generic/HashMap.mqh>

class CMem {
private:
  CHashMap<string,string> m_Pointer2Info;
public:
  CMem() {
    m_Pointer2Info.Clear();
  }
  ~CMem() {
    m_Pointer2Info.Clear();
  }

  void mynew (const string fname, const int lineno, const void *ptr, const string type) {
    string desc = StringFormat("%x",ptr);
    string info = StringFormat ("File %s line %d: desc %s type %s", fname, lineno-2, desc, type);
    if (!m_Pointer2Info.Add (desc, info)) {
      PrintFormat ("%s ERROR m_Pointer2Info.Add", __FUNCTION__);
    }
  }

  void mydelete (const void *ptr) {
    string desc = StringFormat("%x",ptr);
    if (!m_Pointer2Info.ContainsKey(desc)) {
      PrintFormat ("%s ERROR m_Pointer2Info does not contain %s", __FUNCTION__, desc);
      return;
    }
    m_Pointer2Info.Remove (desc);
  }

  void Resume(void) {
    Print ("-- Resume Memory Leaks --");

    string desc[], info[];
    ArrayFree (desc);
    ArrayFree (info);
    m_Pointer2Info.CopyTo (desc,info);
    int size=ArraySize(desc);
    if (size == 0) {
      Print ("  no memory leaks");
    } else {
      PrintFormat ("%d undeleted objects left", size);
      for (int i=0; i<size; i++) {
	PrintFormat ("%s", info[i]);
      }
    }
    Print ("-- End Resume --");
  }
};

#endif
